Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1358182 - [Doc RFE] need to add documentation for expanding a disperse volume
Summary: [Doc RFE] need to add documentation for expanding a disperse volume
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: doc-Administration_Guide
Version: rhgs-3.1
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
: RHGS 3.2.0
Assignee: Divya
QA Contact: nchilaka
URL:
Whiteboard:
Depends On:
Blocks: 1351549
TreeView+ depends on / blocked
 
Reported: 2016-07-20 09:16 UTC by nchilaka
Modified: 2017-03-24 10:20 UTC (History)
13 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-03-24 10:20:32 UTC
divya: needinfo-


Attachments (Terms of Use)

Description nchilaka 2016-07-20 09:16:29 UTC
currently there is no explanation on how to add bricks to expand a disperse(EC) or dist-disperse volume.
Kindly add this info
http://jenkinscat.gsslab.pnq.redhat.com:8080/job/doc-Red_Hat_Gluster_Storage-3.1.3-Administration_Guide%20%28html-single%29/lastStableBuild/artifact/tmp/en-US/html-single/index.html#Expanding_Volumes

Document URL: 

Section Number and Name: 

Describe the issue: 

Suggestions for improvement: 

Additional information:

Comment 4 Divya 2016-09-21 08:34:44 UTC
Pranith,

Could you provide me the steps for expanding disperse volume?

Thanks,
Divya

Comment 5 Pranith Kumar K 2016-10-13 17:53:37 UTC
Ashish,
   Could you help Divya with this?

Comment 6 Ashish Pandey 2016-10-14 07:51:27 UTC
Hi Divya,

Following are the detailed steps and information to do expansion in disperse volume.
------------------------------------------
Expansion  of a disperse volume can be done by adding new bricks.  Command used to add brick is as follows .
gluster volume add-brick <volname> <new bricks paths>

Example:
volume info before adding any brick -

Volume Name: vol
Type: Disperse
Volume ID: 2be607f2-f961-4c4b-aa26-51dcb48b97df
Status: Started
Snapshot Count: 0
Number of Bricks: 1 x (4 + 2) = 6
Transport-type: tcp
Bricks:
Brick1: apandey:/brick/gluster/vol-1
Brick2: apandey:/brick/gluster/vol-2
Brick3: apandey:/brick/gluster/vol-3
Brick4: apandey:/brick/gluster/vol-4
Brick5: apandey:/brick/gluster/vol-5
Brick6: apandey:/brick/gluster/vol-6
Options Reconfigured:
transport.address-family: inet
performance.readdir-ahead: on
nfs.disable: on

Add 6 bricks -
gluster volume add-brick vol apandey:/brick/gluster/vol-11 apandey:/brick/gluster/vol-12 apandey:/brick/gluster/vol-13 apandey:/brick/gluster/vol-14 apandey:/brick/gluster/vol-15 apandey:/brick/gluster/vol-16

Volume info after adding any brick -

Volume Name: vol
Type: Distributed-Disperse
Volume ID: 2be607f2-f961-4c4b-aa26-51dcb48b97df
Status: Started
Snapshot Count: 0
Number of Bricks: 2 x (4 + 2) = 12
Transport-type: tcp
Bricks:
Brick1: apandey:/brick/gluster/vol-1
Brick2: apandey:/brick/gluster/vol-2
Brick3: apandey:/brick/gluster/vol-3
Brick4: apandey:/brick/gluster/vol-4
Brick5: apandey:/brick/gluster/vol-5
Brick6: apandey:/brick/gluster/vol-6
Brick7: apandey:/brick/gluster/vol-11
Brick8: apandey:/brick/gluster/vol-12
Brick9: apandey:/brick/gluster/vol-13
Brick10: apandey:/brick/gluster/vol-14
Brick11: apandey:/brick/gluster/vol-15
Brick12: apandey:/brick/gluster/vol-16
Options Reconfigured:
transport.address-family: inet
performance.readdir-ahead: on
nfs.disable: on
Status of volume: vol


We just have to keep few things in mind while adding bricks in an existing disperse volume.
1 - Number of additional bricks should be exactly in multiple of basic configuration of disperse volume.
     Suppose we have a volume "test-vol" with configuration (4+2 = 6),  then we can only add 6 (4+2) or multiple of 6 bricks  i.e. 12, 18, 24 and so on.

2 - These new bricks will become a disperse sub volume for dht that mean we will have a distributed disperse volume. Note that the "Type" of volume in above example has been changed to "Distributed-Disperse"
     from "Disperse".
     If user creates new files after adding bricks to existing volume, it might go to any subvolume.
     However, the file created before adding new bricks will not be moved to new bricks (or sub volume) automatically. User will have to run a re-balance command manually to equally
     distribute the already existing files among new and old bricks.

 gluster v rebalance <volname>  start
 gluster v rebalance <volname>  status

------------------------------------------
Rephrase it as per your guidelines. Please let me know if anything is not clear to you. I can also review it after you add it in doc.

Ashish

Comment 7 Divya 2016-11-09 06:08:00 UTC
(In reply to Ashish Pandey from comment #6)
> Hi Divya,
> 
> Following are the detailed steps and information to do expansion in disperse
> volume.
> ------------------------------------------
> Expansion  of a disperse volume can be done by adding new bricks.  Command
> used to add brick is as follows .
> gluster volume add-brick <volname> <new bricks paths>
> 
> Example:
> volume info before adding any brick -
> 
> Volume Name: vol
> Type: Disperse
> Volume ID: 2be607f2-f961-4c4b-aa26-51dcb48b97df
> Status: Started
> Snapshot Count: 0
> Number of Bricks: 1 x (4 + 2) = 6
> Transport-type: tcp
> Bricks:
> Brick1: apandey:/brick/gluster/vol-1
> Brick2: apandey:/brick/gluster/vol-2
> Brick3: apandey:/brick/gluster/vol-3
> Brick4: apandey:/brick/gluster/vol-4
> Brick5: apandey:/brick/gluster/vol-5
> Brick6: apandey:/brick/gluster/vol-6
> Options Reconfigured:
> transport.address-family: inet
> performance.readdir-ahead: on
> nfs.disable: on
> 
> Add 6 bricks -
> gluster volume add-brick vol apandey:/brick/gluster/vol-11
> apandey:/brick/gluster/vol-12 apandey:/brick/gluster/vol-13
> apandey:/brick/gluster/vol-14 apandey:/brick/gluster/vol-15
> apandey:/brick/gluster/vol-16
> 
> Volume info after adding any brick -
> 
> Volume Name: vol
> Type: Distributed-Disperse
> Volume ID: 2be607f2-f961-4c4b-aa26-51dcb48b97df
> Status: Started
> Snapshot Count: 0
> Number of Bricks: 2 x (4 + 2) = 12
> Transport-type: tcp
> Bricks:
> Brick1: apandey:/brick/gluster/vol-1
> Brick2: apandey:/brick/gluster/vol-2
> Brick3: apandey:/brick/gluster/vol-3
> Brick4: apandey:/brick/gluster/vol-4
> Brick5: apandey:/brick/gluster/vol-5
> Brick6: apandey:/brick/gluster/vol-6
> Brick7: apandey:/brick/gluster/vol-11
> Brick8: apandey:/brick/gluster/vol-12
> Brick9: apandey:/brick/gluster/vol-13
> Brick10: apandey:/brick/gluster/vol-14
> Brick11: apandey:/brick/gluster/vol-15
> Brick12: apandey:/brick/gluster/vol-16
> Options Reconfigured:
> transport.address-family: inet
> performance.readdir-ahead: on
> nfs.disable: on
> Status of volume: vol
> 
> 
> We just have to keep few things in mind while adding bricks in an existing
> disperse volume.
> 1 - Number of additional bricks should be exactly in multiple of basic
> configuration of disperse volume.
>      Suppose we have a volume "test-vol" with configuration (4+2 = 6),  then
> we can only add 6 (4+2) or multiple of 6 bricks  i.e. 12, 18, 24 and so on.
> 
> 2 - These new bricks will become a disperse sub volume for dht that mean we
> will have a distributed disperse volume. Note that the "Type" of volume in
> above example has been changed to "Distributed-Disperse"
>      from "Disperse".
>      If user creates new files after adding bricks to existing volume, it
> might go to any subvolume.
>      However, the file created before adding new bricks will not be moved to
> new bricks (or sub volume) automatically. User will have to run a re-balance
> command manually to equally
>      distribute the already existing files among new and old bricks.
> 
>  gluster v rebalance <volname>  start
>  gluster v rebalance <volname>  status
> 
> ------------------------------------------
> Rephrase it as per your guidelines. Please let me know if anything is not
> clear to you. I can also review it after you add it in doc.
> 
> Ashish

Thanks for your inputs, Ashish!

I drafted the steps to on how to expand a Dispersed or Distributed-dispersed Volume based on your inputs and is available at: https://docs.google.com/document/d/1MX9YID59wTteUaDMt9p-OMFBAG8Yebg0gF8mJHZ14KI/edit#heading=h.zd4x9gj3vyw0 

Could you please review and share your feedback in the google doc?

Thanks,

Comment 8 Ashish Pandey 2016-11-16 07:42:24 UTC
I have reviewed the doc and provided my comments. I would like to have a look again once it is place in admin guide.

Comment 9 Divya 2016-12-01 05:53:23 UTC
(In reply to Ashish Pandey from comment #8)
> I have reviewed the doc and provided my comments. I would like to have a
> look again once it is place in admin guide.

Ashish,

Thanks for the comments. I have incorporated your comments and ported the content from the google doc to the Admin Guide.

Link to the guide: http://ccs-jenkins.gsslab.brq.redhat.com:8080/job/doc-Red_Hat_Gluster_Storage-3.2-Administration_Guide-branch-BZ-1358182-Expanding_a_dispersed_volume/lastSuccessfulBuild/artifact/tmp/en-US/html-single/index.html#chap-Managing_Red_Hat_Storage_Volumes-Expanding_Dispersed_Volume

Could you please review and sign-off?

Cheers,
Divya

Comment 10 Ashish Pandey 2016-12-05 08:22:59 UTC
Everything looks fine.

Following suggestion, in << >>, just to ensure consistency -

If you add << remove 4+2>> bricks to a Dispersed volume, it will be converted to a Distributed-Dispersed volume, and the existing dispersed volume will be treated as dispersed sub volumes <<added "s">>. 

I have reviewed the content and it is correct.

Comment 11 Divya 2016-12-05 08:36:20 UTC
(In reply to Ashish Pandey from comment #10)
> Everything looks fine.
> 
> Following suggestion, in << >>, just to ensure consistency -
> 
> If you add << remove 4+2>> bricks to a Dispersed volume, it will be
> converted to a Distributed-Dispersed volume, and the existing dispersed
> volume will be treated as dispersed sub volumes <<added "s">>. 
> 
> I have reviewed the content and it is correct.

Thanks for your suggestion, Ashish. I makes sense to delete the brick count and have deleted it in the doc.

Link to the doc: http://ccs-jenkins.gsslab.brq.redhat.com:8080/job/doc-Red_Hat_Gluster_Storage-3.2-Administration_Guide-branch-BZ-1358182-Expanding_a_dispersed_volume/lastSuccessfulBuild/artifact/tmp/en-US/html-single/index.html#chap-Managing_Red_Hat_Storage_Volumes-Expanding_Dispersed_Volume

Comment 12 Divya 2016-12-05 08:39:45 UTC
Merge request WIP lodged here: https://gitlab.cee.redhat.com/red-hat-gluster-storage-documentation/3.2-Administration_Guide/merge_requests/23

This is now waiting on peer review to move to ON_QA.

NI on Anjana to assign a reviewer.

Comment 14 Bhavana 2016-12-08 09:43:44 UTC
I have shared my review comments to Divya over an email.

Comment 15 Divya 2016-12-08 10:12:29 UTC
(In reply to Bhavana from comment #14)
> I have shared my review comments to Divya over an email.

Thanks Bhavana.

Incorporated peer review comments; setting to ON_QA.

You can find "Expanding a Dispersed or Distributed-dispersed Volume" information here: http://ccs-jenkins.gsslab.brq.redhat.com:8080/job/doc-Red_Hat_Gluster_Storage-3.2-Administration_Guide-branch-master/lastSuccessfulBuild/artifact/tmp/en-US/html-single/index.html#chap-Managing_Red_Hat_Storage_Volumes-Expanding_Dispersed_Volume

Please keep in mind that this build contains only merged changes and not all changes for RHGS 3.2 are merged yet.

Comment 16 nchilaka 2017-02-07 06:39:10 UTC
Looks good to me.
However another question,
any particular reason we are not documenting shrinking of a distributed-disperse volume

Comment 17 Divya 2017-02-07 07:03:54 UTC
(In reply to nchilaka from comment #16)
> Looks good to me.
> However another question,
> any particular reason we are not documenting shrinking of a
> distributed-disperse volume

We assume that users can follow "10.4. Shrinking Volumes' section to shrink distributed-disperse volume.

If you think otherwise, please go ahead and raise an RFE, we will address it as soon as we can.

Comment 18 nchilaka 2017-02-07 10:12:14 UTC
ok fine

Comment 19 Rejy M Cyriac 2017-03-24 10:20:32 UTC
RHGS 3.2.0 GA completed on 23 March 2017


Note You need to log in before you can comment on or make changes to this bug.